SDL_endian.h File Reference
`#include "SDL_stdinc.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_endian.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

Swap to native
Byteswap item from the specified endianness to the native endianness.
#define | SDL_SwapLE16(X) SDL_Swap16(X)
#define | SDL_SwapLE32(X) SDL_Swap32(X)
#define | SDL_SwapLE64(X) SDL_Swap64(X)
#define | SDL_SwapFloatLE(X) SDL_SwapFloat(X)
#define | SDL_SwapBE16(X) (X)
#define | SDL_SwapBE32(X) (X)
#define | SDL_SwapBE64(X) (X)
#define | SDL_SwapFloatBE(X) (X)

## The two types of endianness

#define | SDL_LIL_ENDIAN 1234
#define | SDL_BIG_ENDIAN 4321
#define | SDL_BYTEORDER SDL_LIL_ENDIAN
SDL_FORCE_INLINE Uint16 | SDL_Swap16 (Uint16 x)
SDL_FORCE_INLINE Uint32 | SDL_Swap32 (Uint32 x)
SDL_FORCE_INLINE Uint64 | SDL_Swap64 (Uint64 x)
SDL_FORCE_INLINE float | SDL_SwapFloat (float x)

## Detailed Description

Functions for reading and writing endian-specific values

Definition in file SDL_endian.h.

## Macro Definition Documentation

## SDL_BIG_ENDIAN

#define SDL_BIG_ENDIAN 4321

Definition at line 38 of file SDL_endian.h.

## SDL_BYTEORDER

#define SDL_BYTEORDER SDL_LIL_ENDIAN

Definition at line 53 of file SDL_endian.h.

## SDL_LIL_ENDIAN

#define SDL_LIL_ENDIAN 1234

Definition at line 37 of file SDL_endian.h.

## SDL_SwapBE16

#define SDL_SwapBE16 | ( |  | X | ) | (X)

Definition at line 245 of file SDL_endian.h.

## SDL_SwapBE32

#define SDL_SwapBE32 | ( |  | X | ) | (X)

Definition at line 246 of file SDL_endian.h.

## SDL_SwapBE64

#define SDL_SwapBE64 | ( |  | X | ) | (X)

Definition at line 247 of file SDL_endian.h.

## SDL_SwapFloatBE

#define SDL_SwapFloatBE | ( |  | X | ) | (X)

Definition at line 248 of file SDL_endian.h.

## SDL_SwapFloatLE

#define SDL_SwapFloatLE | ( |  | X | ) | SDL_SwapFloat(X)

Definition at line 244 of file SDL_endian.h.

## SDL_SwapLE16

#define SDL_SwapLE16 | ( |  | X | ) | SDL_Swap16(X)

Definition at line 241 of file SDL_endian.h.

## SDL_SwapLE32

#define SDL_SwapLE32 | ( |  | X | ) | SDL_Swap32(X)

Definition at line 242 of file SDL_endian.h.

## SDL_SwapLE64

#define SDL_SwapLE64 | ( |  | X | ) | SDL_Swap64(X)

Definition at line 243 of file SDL_endian.h.

## Function Documentation

## SDL_Swap16()

SDL_FORCE_INLINE Uint16 SDL_Swap16 | ( | Uint16 | x | ) |

Definition at line 107 of file SDL_endian.h.

{
return SDL_static_cast(Uint16, ((x << 8) | (x >> 8)));
}

References SDL_static_cast.

Referenced by platform_testEndianessAndSwap(), SDL_ConvertPixels_SwapNV(), SDL_LoadBMP_RW(), and TestEndian().

## SDL_Swap32()

SDL_FORCE_INLINE Uint32 SDL_Swap32 | ( | Uint32 | x | ) |

Definition at line 162 of file SDL_endian.h.

{
return SDL_static_cast(Uint32, ((x << 24) | ((x << 8) & 0x00FF0000) |
((x >> 8) & 0x0000FF00) | (x >> 24)));
}

References SDL_static_cast.

Referenced by platform_testEndianessAndSwap(), SDL_LoadBMP_RW(), SDL_Swap64(), SDL_SwapFloat(), and TestEndian().

## SDL_Swap64()

SDL_FORCE_INLINE Uint64 SDL_Swap64 | ( | Uint64 | x | ) |

Definition at line 196 of file SDL_endian.h.

{
Uint32 hi, lo;
/* Separate into high and low 32-bit values and swap them */
lo = SDL_static_cast(Uint32, x & 0xFFFFFFFF);
x >>= 32;
hi = SDL_static_cast(Uint32, x & 0xFFFFFFFF);
x = SDL_Swap32(lo);
x <<= 32;
x |= SDL_Swap32(hi);
return (x);
}

References SDL_static_cast, and SDL_Swap32().

Referenced by platform_testEndianessAndSwap(), and TestEndian().

## SDL_SwapFloat()

SDL_FORCE_INLINE float SDL_SwapFloat | ( | float | x | ) |

Definition at line 213 of file SDL_endian.h.

{
union
{
float f;
Uint32 ui32;
} swapper;
swapper.f = x;
swapper.ui32 = SDL_Swap32(swapper.ui32);
return swapper.f;
}

References SDL_Swap32().

Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:203
SDL_static_cast
#define SDL_static_cast(type, expression)
Definition: SDL_stdinc.h:138
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
f
GLfloat f
Definition: SDL_opengl_glext.h:1870
SDL_Swap32
SDL_FORCE_INLINE Uint32 SDL_Swap32(Uint32 x)
Definition: SDL_endian.h:162
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:191